=== main/sysui/desktop/debian/control ===
Description: %productname desktop integration
 This package provides desktop icons and menus for %productname
Maintainer: Apache Software Foundation <dev@openoffice.apache.org>
Architecture: all
Provides: openoffice-desktop-integration, openoffice.org-unbundled
Conflicts: openoffice-desktop-integration, openofficeorg-desktop-integration, openoffice.org-debian-menus
Replaces: openoffice-desktop-integration, openoffice.org-debian-menus, openoffice.org-bundled, openoffice.org-common
